/*
 * MatchesFrame.java
 * 
 * Implements a JFrame which allows the user to select from a list of matches
 * which addon is correct, or manually specify the UID if needed.
 *
 * Created on March 11, 2007, 4:18 AM
 *
 * Copyright (c) 2007 Matthew P. Del Buono
 * 
 * 
 *     This file is part of the WoWInterface UI Manager (WoWIUpdater)
 *
 *     WoWIUpdater is free software; you can redistribute it and/or modify 
 *     it under the terms of the GNU General Public License as published by 
 *     the Free Software Foundation; either version 2 of the License, or 
 *     (at your option) any later version.
 *
 *     WoWIUpdater is distributed in the hope that it will be useful, but 
 *     WITHOUT ANY WARRANTY; without even the implied warranty of 
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
 *     General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public License
 *     along with this program; if not, write to the Free Software
 *     Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
 * 
 *     To contact the author, please send an e-mail to
 *     Matthew.Delbuono@erau.edu or contact "Shirik" via forum private
 *     message at http://www.wowinterface.com or contact the following
 *     physical address:
 *
 *          Matthew P. Del Buono
 *          600 S Clyde Morris Blvd
 *          Mail #146379
 *          Daytona Beach, FL 32114
 *          United States of America
 */

package wowiupdater;

import java.util.Vector;
import javax.swing.JList;
import javax.swing.JOptionPane;
import javax.swing.ListSelectionModel;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

/**
 * Implements a JFrame which allows the user to select from a list of matches
 * which addon is correct, or manually specify the UID if needed.
 * @author  m.delbuono
 */
public class MatchesFrame extends javax.swing.JFrame 
        implements ListSelectionListener 
{
    JList list;
    MatcherSuspender callback;

    private Vector<FavoritesEntry> listData;
    /** Creates new form MatchesFrame */
    public MatchesFrame() {
        initComponents();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        buttonGroup1 = new javax.swing.ButtonGroup();
        jLabel1 = new javax.swing.JLabel();
        jPanel1 = new javax.swing.JPanel();
        jLabel5 = new javax.swing.JLabel();
        jLabel6 = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();
        Addon = new javax.swing.JTextField();
        Author = new javax.swing.JTextField();
        Version = new javax.swing.JTextField();
        jPanel2 = new javax.swing.JPanel();
        matches = new javax.swing.JScrollPane();
        radioSelect = new javax.swing.JRadioButton();
        radioManual = new javax.swing.JRadioButton();
        jLabel2 = new javax.swing.JLabel();
        UID = new javax.swing.JTextField();
        btnCancel = new javax.swing.JButton();
        btnOK = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DO_NOTHING_ON_CLOSE);
        jLabel1.setText("The following matches were found for this addon. Please select the correct one.");

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder("TOC Data"));
        jLabel5.setText("Addon");

        jLabel6.setText("Author");

        jLabel7.setText("Version");

        Addon.setEditable(false);
        Addon.setText("jTextField1");

        Author.setEditable(false);
        Author.setText("jTextField2");

        Version.setEditable(false);
        Version.setText("jTextField3");

        org.jdesktop.layout.GroupLayout jPanel1Layout = new org.jdesktop.layout.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jLabel5)
                    .add(jLabel6)
                    .add(jLabel7))
                .add(41, 41, 41)
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(Addon, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 98, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(Version, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 98, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(Author, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 98, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel5)
                    .add(Addon, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel6)
                    .add(Author, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel7)
                    .add(Version, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel1.getAccessibleContext().setAccessibleName("TOC Data");

        jPanel2.setBorder(javax.swing.BorderFactory.createTitledBorder("Matches (Score)"));
        list = new JList();
        list.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        matches.setViewportView(list);
        list.addListSelectionListener(this);

        radioManual.doClick();
        radioSelect.doClick();

        org.jdesktop.layout.GroupLayout jPanel2Layout = new org.jdesktop.layout.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(matches, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 168, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(matches, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 178, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
        );

        buttonGroup1.add(radioSelect);
        radioSelect.setSelected(true);
        radioSelect.setText("Select from list");
        radioSelect.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        radioSelect.setMargin(new java.awt.Insets(0, 0, 0, 0));
        radioSelect.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                radioSelectActionPerformed(evt);
            }
        });
        radioSelect.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                radioSelectStateChanged(evt);
            }
        });
        radioSelect.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                radioSelectMouseClicked(evt);
            }
        });

        buttonGroup1.add(radioManual);
        radioManual.setText("Enter Manually");
        radioManual.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        radioManual.setMargin(new java.awt.Insets(0, 0, 0, 0));
        radioManual.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                radioManualActionPerformed(evt);
            }
        });
        radioManual.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                radioManualStateChanged(evt);
            }
        });
        radioManual.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                radioManualMouseClicked(evt);
            }
        });

        jLabel2.setText("UID");

        UID.setEditable(false);
        UID.setText("jTextField1");

        btnCancel.setText("Cancel");
        btnCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnCancelActionPerformed(evt);
            }
        });

        btnOK.setText("OK");
        btnOK.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnOKActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                    .add(jLabel1)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                        .add(jPanel2, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                            .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                                .add(layout.createSequentialGroup()
                                    .add(10, 10, 10)
                                    .add(jLabel2)
                                    .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .add(UID, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 168, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                                .add(layout.createSequentialGroup()
                                    .add(radioSelect)
                                    .add(18, 18, 18)
                                    .add(radioManual))
                                .add(jPanel1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                            .add(layout.createSequentialGroup()
                                .add(btnOK)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(btnCancel)))))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(jLabel1)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jPanel2, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(layout.createSequentialGroup()
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(radioSelect)
                            .add(radioManual))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jPanel1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(jLabel2)
                            .add(UID, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 18, Short.MAX_VALUE)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(btnCancel)
                            .add(btnOK))))
                .addContainerGap())
        );
        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void radioManualMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_radioManualMouseClicked
        // Deselect all matches and enable the uid box
        radioSelect.setSelected(false);
        list.clearSelection();
        list.setEnabled(false);
        UID.setEditable(true);
        //System.out.println("OK1!");
    }//GEN-LAST:event_radioManualMouseClicked

    private void radioSelectMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_radioSelectMouseClicked
        // Deselect all matches and enable the list box
        radioManual.setSelected(false);
        list.clearSelection();
        list.setEnabled(true);
        UID.setEditable(false);
        //System.out.println("OK2!");
    }//GEN-LAST:event_radioSelectMouseClicked

    private void radioSelectStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_radioSelectStateChanged
        
    }//GEN-LAST:event_radioSelectStateChanged

    private void radioManualStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_radioManualStateChanged
        // This is a hackish fix for now, which temporarily resolves the issue where
        // the manual state refuses to change the first time (why, who knows...)
        /* FIXED - Issue was an invalid index hidden deep in the call stack
        if (!UID.isEditable() && radioManual.isSelected())
        {
            radioSelect.setSelected(false);
            list.clearSelection();
            list.setEnabled(false);
            UID.setEditable(true);
            System.out.println("OK3!");
        }*/
    }//GEN-LAST:event_radioManualStateChanged

    private void btnCancelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnCancelActionPerformed
        callback.setStatus(MatcherSuspender.CANCEL_STATUS);
        callback.actionPerformed(evt);
        this.dispose();
    }//GEN-LAST:event_btnCancelActionPerformed

    private void btnOKActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnOKActionPerformed
        // Check that the UID is valid
        try
        {
            int a = Integer.parseInt(UID.getText());
        }
        catch (NumberFormatException e)
        {
            JOptionPane.showMessageDialog(this, "The UID you supplied is not valid. "+
                    "If you do not know this addon's UID, please visit "+
                    "http://www.wowinterface.com, search for the addon, and "+
                    "look in your browser's address bar for the numerical ID.",
                    "Invalid UID", JOptionPane.WARNING_MESSAGE);
            return;
        }
        // Ok, good to go
        callback.setStatus(MatcherSuspender.OK_STATUS);
        callback.actionPerformed(evt);
        this.dispose();
    }//GEN-LAST:event_btnOKActionPerformed

    private void radioManualActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_radioManualActionPerformed
        
    }//GEN-LAST:event_radioManualActionPerformed

    private void radioSelectActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_radioSelectActionPerformed
        
    }//GEN-LAST:event_radioSelectActionPerformed
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new MatchesFrame().setVisible(true);
            }
        });
    }

    /** Sets the callback to call when this frame is finished */
    public void setCallbacks(MatcherSuspender cb) {
        callback = cb;
    }

    /** Identifies the addons to be shown in the matcher frame 
     * @param addon the addon in question
     * @param matches the matching entries
     * @see wowiupdater.FavoritesEntry
     */
    public void identify(Addon addon, Vector<FavoritesEntry> matches) {
        Addon.setText(addon.GetName());
        Author.setText(addon.GetAuthor());
        Version.setText(addon.GetVersion());
        // Load the list
        listData = matches;
        for (int i = 0; i < matches.size(); i++)
        {
            list.setListData(matches);
        }
        
        list.setSelectedIndex(0);
        SetUIDIndex(0);
        
    }

    /** Gets the UID of the chosen match
     * @return the UID of the selected addon
     */
    public int GetUID() {
        return Integer.parseInt(UID.getText());
    }

    /** Handles changed values in the dialog list, through a ListListener
     * @param e the event that occurred
     */
    public void valueChanged(ListSelectionEvent e) {
        if (list.getSelectedIndex() != -1)
            SetUIDIndex(list.getSelectedIndex());
    }
    
    private void SetUIDIndex(int i)
    {
        UID.setText(String.valueOf(listData.get(i).uid));
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTextField Addon;
    private javax.swing.JTextField Author;
    private javax.swing.JTextField UID;
    private javax.swing.JTextField Version;
    private javax.swing.JButton btnCancel;
    private javax.swing.JButton btnOK;
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JScrollPane matches;
    private javax.swing.JRadioButton radioManual;
    private javax.swing.JRadioButton radioSelect;
    // End of variables declaration//GEN-END:variables
    
}
