/*
 * Modules.java
 *
 * Helpful class to assist with platform independence. This is designed
 * to replace certain components of the JVM which may not be available in
 * certain platform JREs (for example, String.format does not currently
 * exist in the GNU JRE for Linux). Uses some native code to handle this.
 *
 * Created on April 5, 2007, 11:48 AM
 *
 * Copyright (c) 2007 Matthew P. Del Buono
 *
 * 
 *     This file is part of the WoWInterface UI Manager (WoWIUpdater)
 *
 *     WoWIUpdater is free software; you can redistribute it and/or modify 
 *     it under the terms of the GNU General Public License as published by 
 *     the Free Software Foundation; either version 2 of the License, or 
 *     (at your option) any later version.
 *
 *     WoWIUpdater is distributed in the hope that it will be useful, but 
 *     WITHOUT ANY WARRANTY; without even the implied warranty of 
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
 *     General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public License
 *     along with this program; if not, write to the Free Software
 *     Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
 * 
 *     To contact the author, please send an e-mail to
 *     Matthew.Delbuono@erau.edu or contact "Shirik" via forum private
 *     message at http://www.wowinterface.com or contact the following
 *     physical address:
 *
 *          Matthew P. Del Buono
 *          600 S Clyde Morris Blvd
 *          Mail #146379
 *          Daytona Beach, FL 32114
 *          United States of America
 */

package wowiupdater;

import java.util.Vector;

/**
 * Helpful class to assist with platform independence. This is designed
 * to replace certain components of the JVM which may not be available in
 * certain platform JREs (for example, String.format does not currently
 * exist in the GNU JRE for Linux). Uses some native code to handle this.
 *
 * @author m.delbuono
 */
public class Modules {
    static
    {
        System.loadLibrary("rarlib");
    }
    /** Creates a new instance of Modules */
    public Modules() {
    }
    
    /** Formats a string using the C-style sprintf()
     * @param pattern the pattern to match
     * @param parms the parameters to fit into the pattern
     * @return a formatted string
     */
    public static native String StringFormat(String pattern, double... parms);
    /** Formats a string using the C-style sprintf()
     * @param pattern the pattern to match
     * @param parm the parameters to fit into the pattern
     * @return a formatted string
     */
    public static native String StringFormat(String pattern, String parm);
    /*public static String StringFormat(String pattern, int... parms)
    {
        double[] dparms = new double[parms.length];
        for (int x = 0; x < parms.length; x++)
        {
            dparms[x] = (double)parms[x];
        }
        return StringFormat(pattern, dparms);
    }*/
    
}
