/*
 * PatcherConnectException.java
 *
 * A PatcherConnectException is an Exception which occurs
 * when the patcher cannot communicate with the server due to
 * an error at the patcher level (not a problem with the actual
 * HTTP connection, etc.). An example of this would be the error
 * thrown when a user is not a premium user.
 *
 * Created on May 15, 2007, 4:10 AM 
 *
 * Copyright (c) 2007 Matthew P. Del Buono
 *
 * 
 *     This file is part of the WoWInterface UI Manager (WoWIUpdater)
 *
 *     WoWIUpdater is free software; you can redistribute it and/or modify 
 *     it under the terms of the GNU General Public License as published by 
 *     the Free Software Foundation; either version 2 of the License, or 
 *     (at your option) any later version.
 *
 *     WoWIUpdater is distributed in the hope that it will be useful, but 
 *     WITHOUT ANY WARRANTY; without even the implied warranty of 
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
 *     General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public License
 *     along with this program; if not, write to the Free Software
 *     Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
 * 
 *     To contact the author, please send an e-mail to
 *     Matthew.Delbuono@erau.edu or contact "Shirik" via forum private
 *     message at http://www.wowinterface.com or contact the following
 *     physical address:
 *
 *          Matthew P. Del Buono
 *          600 S Clyde Morris Blvd
 *          Mail #146379
 *          Daytona Beach, FL 32114
 *          United States of America
 */

package wowiupdater;

/**
 *
 * @author m.delbuono
 */
public class PatcherConnectException extends Exception {
    
    private int id;
    
    /** Creates a new instance of PatcherConnectException 
     * @param <tt>id</tt> the error code that occurred
     * @param <tt>message</tt> a human-readable message corresponding
     * to the error
     */
    public PatcherConnectException(int id, String message) {
        super(message);
        this.id = id;
    }
    
}
