/*
 * SVFilter.java
 *
 * Implements a FileFilter for SavedVariable files (LUA type)
 *
 * Created on April 6, 2007, 7:17 AM
 *
 * Copyright (c) 2007 Matthew P. Del Buono
 *
 * 
 *     This file is part of the WoWInterface UI Manager (WoWIUpdater)
 *
 *     WoWIUpdater is free software; you can redistribute it and/or modify 
 *     it under the terms of the GNU General Public License as published by 
 *     the Free Software Foundation; either version 2 of the License, or 
 *     (at your option) any later version.
 *
 *     WoWIUpdater is distributed in the hope that it will be useful, but 
 *     WITHOUT ANY WARRANTY; without even the implied warranty of 
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
 *     General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public License
 *     along with this program; if not, write to the Free Software
 *     Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
 * 
 *     To contact the author, please send an e-mail to
 *     Matthew.Delbuono@erau.edu or contact "Shirik" via forum private
 *     message at http://www.wowinterface.com or contact the following
 *     physical address:
 *
 *          Matthew P. Del Buono
 *          600 S Clyde Morris Blvd
 *          Mail #146379
 *          Daytona Beach, FL 32114
 *          United States of America
 */

package wowiupdater;

import java.io.File;
import java.io.FileFilter;

/**
 * Implements a FileFilter for SavedVariable files (LUA type)
 * @author m.delbuono
 */
public class SVFilter implements FileFilter {
    private String name;
    /** Creates a new instance of SVFilter */
    public SVFilter(String name) {
        this.name = name;
    }

    /** Determines if this file is a Saved Variable file
     * @param pathname the <tt>File</tt> to test
     * @return <tt>true</tt> if this is a Saved Variable file, <tt>false</tt>
     * if not
     */
    public boolean accept(File pathname) {
        if (pathname.isDirectory())
            return false;
        
        if (pathname.getName().equalsIgnoreCase(name + ".lua"))
            return true;
        
        return false;
    }
}
